﻿# laufzeitentest-TS-viele.py
# Programm zum Füllen von Containern mit Tiefensuche
# (Rucksackproblem)

# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

### Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])
def alle_voll(alleContainer):
    for container in alleContainer:
        if not(ist_voll(container)):
            return False
    return True
### ... mit dem Stück zu voll wird.
def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])


def fuelle(stuecke, alleContainer):
    ##input(str((stuecke,alleContainer))) # verfolgen
    if alle_voll(alleContainer):
        return alleContainer
    if len(stuecke)==0:
        return False
    # Zunächst mit dem Stück in allen versuchen - wenn es geht
    for i in range(len(alleContainer)):
        if not(wird_zu_voll(stuecke[0], alleContainer[i])):
            ergebnis=fuelle(stuecke[1:],
                            alleContainer[:i]+ # alle davor
                            [fuelle_ein(stuecke[0],alleContainer[i])]+
                            alleContainer[i+1:]) # alle danach
            if ergebnis: return ergebnis
    # In jedem Fall auch ohne das Stück versuchen:
    ergebnis=fuelle(stuecke[1:],alleContainer)
    if ergebnis: return ergebnis
    return False


import time

##### ---------------------------------------------------------------
##start=time.perf_counter() # Py 3.x-Variante
##alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
##stuecke=[60,40,30,30,30,20,20,20] # erfolglos !
##print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
##stopp=time.perf_counter()
##print(stopp-start)
##
##start=time.perf_counter() # Py 3.x-Variante
##alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
##stuecke=[60,40,30,30,30,20,20,20,1] ###### ÄNDERUNG
##print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
##stopp=time.perf_counter()
##print(stopp-start)
##
##start=time.perf_counter() # Py 3.x-Variante
##alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
##stuecke=[60,40,30,30,30,20,20,20,1,1] ###### ÄNDERUNG
##print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
##stopp=time.perf_counter()
##print(stopp-start)
##
##start=time.perf_counter() # Py 3.x-Variante
##alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
##stuecke=[60,40,30,30,30,20,20,20,1,1,1] ###### ÄNDERUNG
##print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
##stopp=time.perf_counter()
##print(stopp-start)
##
##start=time.perf_counter() # Py 3.x-Variante
##alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
##stuecke=[60,40,30,30,30,20,20,20,1,1,1,1] ###### ÄNDERUNG
##print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
##stopp=time.perf_counter()
##print(stopp-start)

##### ---------------------------------------------------------------
start=time.perf_counter() # Py 3.x-Variante
alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80)]
stuecke=[60,40,30,30,30,20,20,20] # erfolglos !
print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
stopp=time.perf_counter()
print(stopp-start)

start=time.perf_counter() # Py 3.x-Variante
alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80),
      erzeuge_Container(100)]
stuecke=[60,40,30,30,30,20,20,20] # erfolglos !
print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
stopp=time.perf_counter()
print(stopp-start)

start=time.perf_counter() # Py 3.x-Variante
alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80),
      erzeuge_Container(100),erzeuge_Container(100)]
stuecke=[60,40,30,30,30,20,20,20] # erfolglos !
print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
stopp=time.perf_counter()
print(stopp-start)

start=time.perf_counter() # Py 3.x-Variante
alle=[erzeuge_Container(100),erzeuge_Container(80),erzeuge_Container(80),
      erzeuge_Container(100),erzeuge_Container(100),erzeuge_Container(100)]
stuecke=[60,40,30,30,30,20,20,20] # erfolglos !
print( stuecke, '100 80 80', 'Ergebnis: ', fuelle(stuecke, alle), '\n')
stopp=time.perf_counter()
print(stopp-start)

